import java.io.*;
import java.net.*;
import java.util.*;
import java.text.*;
import java.lang.*;

public class WebServer{
	private int    gThreadID=1;
	private String gServerName="yServW/0.19";
	private String olddate="xxxx/xx/xx_xx:xx:xx";
	
	private String conf_webroot  ="";
	private String conf_port     ="80";
	private String conf_filelist ="false";
	private String conf_webmaster="";
	private String conf_monitor  ="false";
	private String conf_logfile  ="log.txt";
	private String conf_execcgi  ="false";
	private String conf_default  ="index.html";
	private String conf_timeout  ="50000";	//	50sec.
	private String conf_debug    ="false";
	
	private String alias_req[] =new String[100];
	private String alias_path[]=new String[100];
	private int    alias_max   =0;
	
	private String hostname[]  =new String[100];
	private int    hostname_max=0;
	
	private String err_dir="";
	private String err_msg[]=new String[100];
	private int    err_no[] =new int[   100];
	private int    err_max  =0;
	
	private String url_unauth[]  =new String[100];
	private int    url_unauth_max=0;
	
	private String host_arrow[]  =new String[100];
	private int    host_arrow_max=0;
	private String host_deny[]   =new String[1000];
	private int    host_deny_max =0;
	
	private String mime_ext[] =new String[100];
	private String mime_type[]=new String[100];
	private int    mime_max   =0;
	
	private String log_ignore[]  =new String[100];
	private int    log_ignore_max=0;
	
	private String cgi_type[]  =new String[100];
	private String cgi_cmd[]   =new String[100];
	private int    cgi_type_max=0;
	
	//	FؐݒpX
	private String auth_path[] =new String[100];
	private int    auth_level[]=new int[   100];
	private int    auth_max    =0;
	
	//	[U[Xg
	private String user_name[]  =new String[100];
	private int    user_hash[]  =new int[   100];
	private int    user_level[] =new int[   100];
	private int    user_max     =0;
	
	private FileTools    file;
	private Subs         subs;
	private CodeExchange code;
	
	public static void main(String[] args){
		new WebServer(args);
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	RXgN^
	//
	public WebServer(String[] args){
		file=new FileTools();
		subs=new Subs();
		code=new CodeExchange();
		GetSettingFile();
		if(AnalyzeOption(args)){
			System.out.println(gServerName+" start at port "+conf_port);
			MainProc();
		}
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	C
	//
	public void MainProc(){
		try{
			ServerSocket serverSocket=new ServerSocket(Integer.parseInt(conf_port));
			while(true){
				try{
					Socket socket=serverSocket.accept();
					new Connect(gThreadID++,socket);
				}
				catch(Exception ex){
					ex.printStackTrace();
				}
			}
		}
		catch(IOException e){
			e.printStackTrace();
		}
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	NIvV̉
	//
	private boolean AnalyzeOption(String[] args){
		boolean retsts=true;
		String str1,str2;
		int i,j,k;
		if(0<args.length){
			for(i=0;i<args.length;i++){
				str1=args[i].substring(0,2);
				str2=args[i].substring(2);
				if     (str1.equals("-v")){	//	Oo
					if (str2.equals("on"))	conf_monitor="true";
					else					conf_monitor="false";
				}
				else if(str1.equals("-d")){
					if (str2.equals("on"))	conf_debug="true";
					else					conf_debug="false";
				}
				else if(str1.equals("-p")){	//	|[gw
					j=-1;
					try{
						j=Integer.parseInt(str2);
					}
					catch(Exception e){}
					if (j!=-1)	conf_port=Integer.toString(j);
					else{
						retsts=false;
						break;
					}
				}
				else{						//	IvV̊ԈႢ
					retsts=false;
					break;
				}
			}
		}
		if(retsts==false){
			System.out.println("usage:");
			System.out.println("java -jar yServW.jar {-v[on|off]} {-p<portnumber>}");
		}
		return retsts;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	ݒt@CǍ
	//
	private void GetSettingFile(){
		GetHttpdConf();		//	httpd.conf
		GetErrorConf();		//	error.conf
		GetUnauthConf();	//	unauth.conf
		GetHostsConf();		//	hosts.conf
		GetMimetypeConf();	//	mimetype.conf
		GetLogConf();		//	log.conf
		GetCgiConf();		//	cgi.conf
		GetAuthentConf();	//	authent.conf
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	httpd.conf
	//
	private void GetHttpdConf(){
		String str1,str2,cmd="",param="";
		StringTokenizer st1,st2;
		int i;
		
		str1=file.FileRead("httpd.conf");
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			cmd="";
			param="";
			st2=new StringTokenizer(str2,"=");
			try{
				cmd=st2.nextToken();
				param=st2.nextToken();
			}
			catch(Exception e){
				param="";
			}
			st2=null;
			if     (cmd.equals("webroot"))		conf_webroot  =param;
			else if(cmd.equals("default"))		conf_default  =param;
			else if(cmd.equals("port"))			conf_port     =param;
			else if(cmd.equals("filelist"))		conf_filelist =param;
			else if(cmd.equals("webmaster"))	conf_webmaster=param;
			else if(cmd.equals("monitor")&&conf_monitor.equals("false"))
												conf_monitor  =param;
			else if(cmd.equals("logfile"))		conf_logfile  =param;
			else if(cmd.equals("execcgi"))		conf_execcgi  =param;
			else if(cmd.equals("timeout"))		conf_timeout  =param;
			else if(cmd.equals("hostname"))		hostname[hostname_max++]=param;
			else if(cmd.equals("alias")){
				st2=new StringTokenizer(param,";");
				try{
					alias_req[ alias_max]=st2.nextToken();
					alias_path[alias_max]=st2.nextToken();
					alias_max++;
				}
				catch(Exception e){}
				st2=null;
			}
		}
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	error.conf
	//
	private void GetErrorConf(){
		String str1,str2,cmd="",param="";
		StringTokenizer st1,st2;
		int i,j;
		
		str1=file.FileRead("error.conf");
		st1=new StringTokenizer(str1,"\n");
		j=0;
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			st2=new StringTokenizer(str2,"=");
			try{
				cmd=st2.nextToken();
				param=st2.nextToken();
			}
			catch(Exception e){
				param="";
			}
			st2=null;
			i=-1;
			try{
				i=Integer.parseInt(cmd);
			}
			catch(Exception e){
				i=-1;
			}
			if     (cmd.equals("dir"))	err_dir=param+"/";
			else if(i!=-1){
				err_no[j]=i;
				err_msg[j]=param;
				j++;
			}
		}
		err_max=j;
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	unauth.conf
	//
	private void GetUnauthConf(){
		String str1;
		StringTokenizer st1;
		str1=file.FileRead("unauth.conf");
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens())	url_unauth[url_unauth_max++]=st1.nextToken();
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	hosts.conf
	//
	private void GetHostsConf(){
		String str1,str2,cmd="",param;
		StringTokenizer st1,st2;
		
		str1=file.FileRead("hosts.conf");
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			st2=new StringTokenizer(str2,"=");
			try{
				cmd  =st2.nextToken();
				param=st2.nextToken();
			}
			catch(Exception e){
				param="";
			}
			st2=null;
			if     (cmd.equals("arrow"))	host_arrow[host_arrow_max++]=param;
			else if(cmd.equals("deny" ))	host_deny[ host_deny_max++ ]=param;
		}
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	mimetype.conf
	//
	private void GetMimetypeConf(){
		String str1,str2,str3,cmd="",param="";
		StringTokenizer st1,st2;
		int i;
		
		str1=file.FileRead("mimetype.conf");
		st1=new StringTokenizer(str1,"\n");
		i=0;
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			st2=new StringTokenizer(str2,"=");
			cmd  =st2.nextToken();	//	Content-type
			param=st2.nextToken();
			st2=null;
			st2=new StringTokenizer(param,",");
			while(st2.hasMoreTokens()){
				str3=st2.nextToken();
				mime_type[i]=cmd;
				mime_ext[ i]=str3;
				i++;
			}
			st2=null;
		}
		st1=null;
		mime_max=i;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	log.conf
	//
	private void GetLogConf(){
		String str1,str2,cmd="",param="";
		StringTokenizer st1,st2;
		
		str1=file.FileRead("log.conf");
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			st2=new StringTokenizer(str2,"=");
			cmd  =st2.nextToken();
			param=st2.nextToken();
			st2=null;
			if(cmd.equals("ignore"))	log_ignore[log_ignore_max++]=param;
		}
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	cgi.conf
	//
	private void GetCgiConf(){
		String str1,str2,cmd="",param="";
		StringTokenizer st1,st2;
		
		str1=file.FileRead("cgi.conf");
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			st2=new StringTokenizer(str2,"=");
			try{
				cmd  =st2.nextToken();
				param=st2.nextToken();
			}
			catch(Exception e){
				param="";
			}
			st2=null;
			cgi_type[cgi_type_max]=cmd;
			cgi_cmd[ cgi_type_max]=param;
			cgi_type_max++;
		}
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	authent.conf
	//
	private void GetAuthentConf(){
		String str1,str2,cmd="",param="";
		StringTokenizer st1,st2;
		
		str1=file.FileRead("authent.conf");
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			st2=new StringTokenizer(str2,"=");
			try{
				cmd  =st2.nextToken();
				param=st2.nextToken();
			}
			catch(Exception e){
				param="";
			}
			st2=null;
			if     (cmd.equals("userlist"))		GetUserList(param);
			else if(cmd.startsWith("level")){
				auth_path[ auth_max]=param;
				auth_level[auth_max]=Integer.parseInt(cmd.substring(5).trim());
				auth_max++;
			}
		}
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	userlist
	//
	private void GetUserList(String filename){
		String str1,str2;
		StringTokenizer st1,st2;
		boolean hashFlag=false;
		
		str1=file.FileRead(filename);
		st1=new StringTokenizer(str1,"\n");
		while(st1.hasMoreTokens()){
			str2=st1.nextToken();
			str2=subs.SelectData(0,str2,"#").trim();	//	RgLɂ
			if(str2.equals("listtype=hash")){
				hashFlag=true;
			}
			else{
				st2=new StringTokenizer(str2,",");
				try{
					user_name[ user_max]=st2.nextToken().trim();
					if(hashFlag)	user_hash[ user_max]=Integer.parseInt(st2.nextToken().trim());
					else			user_hash[ user_max]=st2.nextToken().trim().hashCode();
					user_level[user_max]=Integer.parseInt(st2.nextToken().trim());
					user_max++;
				}
				catch(Exception e){
				}
				st2=null;
			}
		}
		st1=null;
	}
	
	/////////////////////////////////////////////////////////////////////////
	//	Ci[NXFMXbh
	//
	class Connect
	extends Thread
	implements Timeout
	{
		private Timer   t;
		private boolean RequestedFlag=false;
		private int     cThreadID;
		private Socket  socket=null;
		private boolean LogFlag;
		private String  LogLineData="";
		private String  req_method="";
		private String  req_url="";
		private String  req_addr="";
		private String  req_cgi="";
		private String  req_http="";
		private String  req_host="";
		private String  req_path="";
		private int     req_status=200;
		private String  req_comment="";
		private int     req_contentlength=-1;
		private int     req_level=0;
		private int     req_userlevel=0;
		private String  ClientIP;
		
		/////////////////////////////////////////////////////////////////////////
		//	MXbhFRXgN^
		//
		public Connect(int mThreadID,Socket socket){
			ClientIP=socket.getInetAddress().toString();
			String newdate;
			int i;
			boolean denyFlag=false;
			
			LogFlag=true;			//	Oo͂邩ۂ̔f
			for(i=0;i<log_ignore_max;i++){
				if(ClientIP.startsWith(log_ignore[i])){
					LogFlag=false;
					break;
				}
			}
			if(0<host_deny_max){	//	ANZX֎~XgT[`
				for(i=0;i<host_deny_max;i++){
					if(ClientIP.startsWith(host_deny[i])){
						denyFlag=true;
						break;
					}
				}
			}
			if(0<host_arrow_max){	//	ANZXXgT[`
				for(i=0;i<host_arrow_max;i++){
					if(ClientIP.startsWith(host_arrow[i])){
						denyFlag=false;
						break;
					}
				}
			}
			if(denyFlag==false){	//	ʏANZX
				Calendar  cal=Calendar.getInstance();	//	̎擾
				DateFormat df=new SimpleDateFormat("yyyy/MM/dd_HH:mm:ss");
				Date       dt=cal.getTime();
				newdate      =df.format(dt).toString();
				if(!newdate.substring(0,10).equals(olddate.substring(0,10))){	//	t
					System.out.println("date changed!!");
					System.out.println("newdate=["+newdate.substring(0,10)+"] olddate=["+olddate.substring(0,10)+"]");
					olddate=newdate;
				}
				
				cThreadID=mThreadID;
				LogLineData=newdate+" "+ClientIP+" ";
				this.socket=socket;
				this.start();
			}
			else{					//	ANZX֎~
			}
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	MXbhC
		//
		public void run(){
			String sts="",req="",mimetype;
			StringTokenizer st1;
			int i,j;
			InputStream  in;
			OutputStream out;
			try{
				in =socket.getInputStream();
				out=socket.getOutputStream();
				
				req=GetRequest(in).trim();
				
				if(req_status!=200 && conf_debug.equals("true")){	//	C^Y͂₸BBB
					//	for debug
					file.FileAdd("debug/log.txt",LogLineData+Integer.toString(req_status)+"\n"+req+"\n");
				}
				
				AnalyzeRequest(req);
				
				sts=SendResponseData(req,in,out);
				LogLineData+=sts+" ";
				if(req_method.equals(""))	LogLineData+="- ";
				else						LogLineData+=req_method+" ";
				LogLineData+=req_url;
				
				out.close();
				in.close();
				socket.close();
			}
			catch(Exception e){
				try{socket.close();}catch(Exception ex){}
			}
			LogDataOut(LogLineData);
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	NGXgwb_M
		//
		private String GetRequest(InputStream in){
			String retmsg="";
			int BuffMax=4096;
			byte[] ReadData=new byte[BuffMax];
			int  ni,i=0;
			
			t=new Timer();
			t.addListener(this);
			t.start(Integer.parseInt(conf_timeout));
			RequestedFlag=true;
			while(RequestedFlag){
				try{
					ni=in.read();	//	1oCgǍ
				}
				catch(Exception e){	//	̏ꍇ̏
					ni=-1;
				}
				if(ni!='\r'){		//	\r ͎̂Ă
					ReadData[i]=(byte)ni;
					if(1<=i){
						if(ReadData[i-1]=='\n' && ReadData[i]=='\n'){
							retmsg=new String(ReadData,0,i);
							t.stop();
							t=null;
							break;
						}
					}
					i++;
					if(BuffMax<=i){
						req_url="-";
						req_status=413;
						retmsg=new String(ReadData,0,i);
						retmsg+="\nlengthout";
						t.stop();
						t=null;
						break;
					}
				}
			}
			if(RequestedFlag==false){
				req_status=408;
				retmsg=new String(ReadData,0,i);
				retmsg+="\ntimeout";
			}
			//	for debug
			if(conf_debug.equals("true")){
				System.out.println(i+" bytes data received.");
				System.out.println("retmsg=["+retmsg+"]");
			}
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	POST bZ[WM
		//
		private String GetContent(InputStream in,int contentlength){
			String retmsg="";
			int BuffMax=contentlength;
			byte[] ReadData=new byte[BuffMax];
			int  ni,i=0;
			
			t=new Timer();
			t.addListener(this);
			t.start(Integer.parseInt(conf_timeout));
//			RequestedFlag=true;
			while(RequestedFlag){
				try{
					ni=in.read();	//	1oCgǍ
				}
				catch(Exception e){	//	̏ꍇ̏
					ni=-1;
				}
				ReadData[i]=(byte)ni;
				i++;
				if(BuffMax<=i){
					retmsg=new String(ReadData,0,i);
					t.stop();
					t=null;
					break;
				}
			}
			if(RequestedFlag==false){
				req_status=408;
				retmsg=new String(ReadData,0,i);
				retmsg+="\ntimeout";
			}
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	NGXgwb_̓\bh
		//	Qljhttp://www.ki.rim.or.jp/~kuro/WebDAV/HTTP-Options-Trace.html
		//		  http://www.atmarkit.co.jp/fnetwork/rensai/netpro02/netpro01.html
		//
		private void AnalyzeRequest(String req){
			StringTokenizer st1,st2,st3;
			String str1,str2,dummy;
			boolean ErrorFlag=false;
			String name;
			int hash;
			int i,j,k;
			char[] ch=new char[100];
			
			if(req_status==200){
				st1=new StringTokenizer(req,"\n");
				
				//	\bhs
				str1=st1.nextToken();
				st2=new StringTokenizer(str1," ");
				req_method=st2.nextToken();
				req_http  ="HTTP/1.0";
				req_url   ="*";
				if(st2.hasMoreTokens()){
					str2=st2.nextToken();
					if(str2.startsWith("HTTP"))	req_http=str2;
					else						req_url =code.decodeUri(str2);
					if(st2.hasMoreTokens()){
						str2=st2.nextToken();
						if(str2.startsWith("HTTP"))	req_http =str2;
						else						ErrorFlag=true;
					}
				}
				st2=null;
				
				//	\bhsȊO
				if(!ErrorFlag){
					while(st1.hasMoreTokens()){
						str1=st1.nextToken();
						if(str1.startsWith("Host: ")){	//	zXg̎w
							st2=new StringTokenizer(str1," ");
							if(st2.hasMoreTokens())	dummy   =st2.nextToken();
							if(st2.hasMoreTokens())	req_host=st2.nextToken();
							if(st2.hasMoreTokens()){	//	sȃNGXg
								ErrorFlag=true;
								st2=null;
								break;
							}
							st2=null;
						}
						else if(str1.startsWith("Content-Length: ")){	//	POST  Content-Length 擾
							req_contentlength=Integer.parseInt(str1.substring(16));
						}
						else if(str1.startsWith("Authorization: Basic ")){	//	BASIC F
							str2=str1.substring(21);
							j=code.DecodeBase64(str2.toCharArray(),str2.length(),ch);
							str2="";
							for(i=0;i<j;i++)	str2+=ch[i];
							name=subs.SelectData(0,str2,":");
							hash=subs.SelectData(1,str2,":").hashCode();
							for(i=0;i<user_max;i++){
								if(user_name[i].equals(name) && user_hash[i]==hash){
									req_userlevel=user_level[i];
									break;
								}
							}
						}
						else{							//	Ή̃NCAg
						}
					}
				}
				st1=null;
				
				if(req_http.equals("HTTP/1.1") || req_http.equals("HTTP/1.2")){
					if(!req_url.startsWith("http://") && !req_host.equals("")){
						j=-1;
						for(i=0;i<hostname_max;i++){
							if(req_host.equals(hostname[i]) || req_host.equals(hostname[i]+":"+conf_port)){
								j=i;
								break;
							}
						}
						if(j==-1){	//	sȃzXg
							ErrorFlag=true;
						}
					}
					else{			//	HTTP/1.1 NGXgG[
						ErrorFlag=true;
					}
				}
				else if(req_http.equals("HTTP/1.0")){
					if(req_url.startsWith("http://")){
						st1=new StringTokenizer(req_url,"/");
						if(2<st1.countTokens() && req_url.endsWith("/"))	str1="/";
						else												str1="";
						dummy   =st1.nextToken();
						req_host=st1.nextToken();
						str2="";
						while(st1.hasMoreTokens()){
							if(!str2.equals(""))	str2+="/";
							str2+=st1.nextToken();
						}
						st1=null;
						str2="/"+str2;
						if(!str2.endsWith("/"))	str2+=str1;
						req_url=str2;
					}
					else{
						j=-1;
						for(i=0;i<hostname_max;i++){
							if(req_host.equals(hostname[i]) || req_host.equals(hostname[i]+":"+conf_port)){
								j=i;
								break;
							}
						}
						if(j==-1){	//	sȃzXg
							ErrorFlag=true;
						}
					}
				}
				if(ErrorFlag==false){
					i=req_url.indexOf("?");
					if(-1<i){
						req_addr=req_url.substring(0,i);
						req_cgi =req_url.substring(i+1);
					}
					else{
						req_addr=req_url;
						req_cgi ="";
					}
				}
			}
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	X|Xf[^o̓f[^
		//	
		//	A^bN聨ubNXgǉ
		//	F؏
		//	^[Qbg̎ނ𔻒it@C^tH_^bfhj
		//	GCAX
		//	^[Qbg݂̑mF
		//	MIME-TYPE̔
		//	F؍ϔ
		//	X|Xwb_EeLXg]
		//	X|X{̂oCi]
		//	OǋL
		//	UTF8fR[hǉ
		//	
		private String SendResponseData(String request,InputStream in,OutputStream out){
			boolean denyFlag =false;
			boolean existFlag=false;
			boolean listFlag =false;
			boolean findFlag =false;
			int     type     =0;	//	0=none,1=file,2=folder,3=CGI
			String  req;
			
			String retmsg="",sendmsg="",mimeType="text/plain",cgi_msg,str1;
			StringTokenizer st1;
			int BuffMax=1024;
			byte[] ReadData=new byte[BuffMax];
			int i;
			
			req=code.decodeUri(request);
			try{
				while(true){
					if(req_status==408)	break;	//	timeout
					
					//	֎~[h̃XL
					if(0<url_unauth_max){
						for(i=0;i<url_unauth_max;i++){
							if(req_url.indexOf(url_unauth[i])!=-1){
								denyFlag=true;
								break;
							}
						}
					}
					if(denyFlag==true && 0<host_arrow_max){
						for(i=0;i<host_arrow_max;i++){
							if(ClientIP.startsWith(host_arrow[i])){
								denyFlag=false;
								break;
							}
						}
					}
					if(denyFlag==true){
						if(0<host_deny_max){
							for(i=0;i<host_deny_max;i++){
								if(ClientIP.startsWith(host_deny[i])){
									findFlag=true;
									break;
								}
							}
						}
						if(findFlag==false){
							LogDataOut("deny="+ClientIP);
							file.FileAdd("hosts.conf","deny="+ClientIP+"\n");
							host_deny[host_deny_max++]=ClientIP;
						}
						req_status=401;
						break;
					}
					if(req_status==413)	break;	//	too length
					
					//	͌_揈
					if(req_url.indexOf("..")!=-1){
						req_status=403;
						break;
					}
					
					//	F؂̗vEsv𔻒
					for(i=0;i<auth_max;i++){
						if(req_url.startsWith(auth_path[i])){
							req_level=auth_level[i];
							break;
						}
					}
					
					//	^[Qbg̎ނ𔻕
					if     (req_url.equals("*"))	type=0;
					else if(req_url.endsWith("/"))	type=2;
					else{
						for(i=0;i<cgi_type_max;i++){
							if(req_addr.endsWith(cgi_type[i])){
								type=3;
								break;
							}
						}
						if(type!=3)	type=1;
					}
					
					if(req_addr.equals("")){
						req_status=405;
						break;
					}
					
					//	GCAX
					req_path=conf_webroot+req_addr;
					if(0<alias_max){
						for(i=0;i<alias_max;i++){
							if(req_addr.startsWith(alias_req[i])){
								req_path =alias_path[i];
								req_path+=req_addr.substring(alias_req[i].length());
								break;
							}
						}
					}
					
					//	^[Qbg݂̑mF
					if(type==0){
						if(req_method.equals("GET") || req_method.equals("HEAD")){
							req_status=405;
						}
					}
					else if(type==1 || type==3){
						i=file.FileType(req_path);
						if(i==0){
							existFlag=false;
							req_status=404;
						}
						else{
							existFlag=true;
							if(i==2){
								type=2;	//	̓tH_
								req_path+="/";
								req_addr+="/";
								req_url +="/";
							}
						}
					}
					if(type==2){
						if(file.FileExist(req_path+conf_default)){
							type=1;
							req_path+=conf_default;
							existFlag=true;
						}
						else{
							if(file.FileExist(req_path)){
								if(conf_filelist.equals("true")){
									listFlag=true;
									existFlag=true;
								}
								else{
									existFlag=true;
									req_status=403;
								}
							}
							else{
								existFlag=false;
								req_status=404;
							}
						}
					}
					break;
				}
			}
			catch(Exception e){
				System.out.println("req=["+req+"]");
				e.printStackTrace();
			}
			
			//	F؃x̔
			if(req_status==200){
				if(req_userlevel<req_level){
					req_status=401;
				}
			}
			
			//	X|Xwb_̐
			sendmsg=MakeHeadder(req_http,req_status);
			
			//	X|X{
			if(req_status==200){
				if     (req_method.equals("OPTIONS")){	//	OPTIONS \bh
					sendmsg+="Public: OPTIONS, TRACE, GET, HEAD, POST\r\n";
					sendmsg+="Allow: OPTIONS, TRACE, GET, HEAD, POST\r\n";
					sendmsg+="\r\n";
					try{
						out.write(sendmsg.getBytes());
						out.flush();
					}
					catch(Exception e){
						System.out.println("OPTIONS Error");
						System.out.println(req);
						e.printStackTrace();
					}
				}
				else if(req_method.equals("TRACE")){	//	TRACE \bh
					sendmsg+="Content-Type: message/http\r\n";
					sendmsg+="\r\n";
					st1=new StringTokenizer(req,"\n");
					while(st1.hasMoreTokens())	sendmsg+=st1.nextToken()+"\r\n";
					st1=null;
					try{
						out.write(sendmsg.getBytes());
						out.flush();
					}
					catch(Exception e){
						System.out.println("TRACE Error");
						System.out.println(req);
						e.printStackTrace();
					}
				}
				else if(req_method.equals("POST")){		//	POST \bh
					//	Content-Length
					if(type==3 && 0<=req_contentlength){	//	CGI̎s
						String contentt=GetContent(in,req_contentlength);
						if(conf_debug.equals("true")){
							System.out.println("POST:len="+req_contentlength);
							System.out.println("Content=["+contentt+"]");
						}
						try{
							if(conf_execcgi.equals("true")){
								out.write(sendmsg.getBytes());
								ExecCGI(out,req_path,contentt);
							}
							else{
								sendmsg+="Content-Type: text/html\r\n";
								sendmsg+="\r\n";
								sendmsg+="<h3>This server didn't allow for execute CGI.</h3>\r\n";
								out.write(sendmsg.getBytes());
							}
						}
						catch(Exception e){
							System.out.println("GET/HEAD -3 Error");
							System.out.println(req);
							e.printStackTrace();
						}
					}
					else{
						req_status=204;
					}
				}
				else if(req_method.equals("GET")||req_method.equals("HEAD")){	//	GET,HEAD \bh
					if     (type==1){	//	t@C̓]
						sendmsg+="Content-Type: "+AnalyzeMimeType(req_path)+"\r\n";
						sendmsg+="Content-length: "+Integer.toString(file.FileSize(req_path))+"\r\n";
						sendmsg+="\r\n";
						try{
							out.write(sendmsg.getBytes());
							if(req_method.equals("GET")){
								FileInputStream indata=new FileInputStream(new File(req_path));
								while(true){
									i=indata.read(ReadData);
									if(i==-1)	break;	//	EOF
									out.write(ReadData,0,i);
								}
								indata.close();
								indata=null;
							}
							out.flush();
						}
						catch(Exception e){
							req_comment+=" -terminated";
						}
					}
					else if(type==2){	//	tH_Xg̓]
						sendmsg+="Content-Type: text/html\r\n";
						sendmsg+="\r\n";
						try{
							if(req_method.equals("GET")){
								sendmsg+=MakeFileList(req_path,req_addr);
							}
							out.write(sendmsg.getBytes());
							out.flush();
						}
						catch(Exception e){
							System.out.println("GET/HEAD -2 Error");
							System.out.println(req);
							e.printStackTrace();
						}
					}
					else if(type==3){	//	bfh̓]
						try{
							if(req_method.equals("GET")){
								if(conf_execcgi.equals("true")){
									out.write(sendmsg.getBytes());
									ExecCGI(out,req_path,req_cgi);
								}
								else{
									sendmsg+="Content-Type: text/html\r\n";
									sendmsg+="\r\n";
									sendmsg+="<h3>This server didn't allow for execute CGI.</h3>\r\n";
									out.write(sendmsg.getBytes());
								}
							}
							else{
								sendmsg+="\r\n";
								out.write(sendmsg.getBytes());
							}
							out.flush();
						}
						catch(Exception e){
							System.out.println("GET/HEAD -3 Error");
							System.out.println(req);
							e.printStackTrace();
						}
					}
					else{
						System.out.println("GET/HEAD type Error : type="+type);
						System.out.println(req);
					}
				}
				else{	//	Ή̃\bh
					req_status=405;
				}
			}
			if(req_status!=200){
				if(req_status==401 && req_userlevel<req_level){
					sendmsg+="WWW-Authenticate: Basic realm= \"Hidden directory\"\r\n";
				}
				sendmsg+="Content-Type: text/html\r\n";
				sendmsg+="\r\n";
				sendmsg+=ErrorOut(req_status);
				try{
					out.write(sendmsg.getBytes());
					out.flush();
				}
				catch(Exception e){}
			}
/*
			req_method		GET
			req_url			/cgi-bin/counter.class?1
			req_addr		/cgi-bin/counter.class
			req_cgi			1
			req_http		HTTP/1.1
			req_host		192.168.1.4:80
			req_path		/webroot/cgi-bin/counter.class
			req_status		200
			req_comment		-terminated
			req_level		authent-level of requested contents
			req_userlevel	authent-level of client
*/
			retmsg=Integer.toString(req_status);
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	^C}[Cxg
		//	ɓǂݍ߂ꍇɃJE^~߂鏈
		//
		public void timeout(){
			RequestedFlag=false;
			if(t!=null){
				t.stop();
				t=null;
			}
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	Oo̓\bh
		//
		private void LogDataOut(String LogData){
			if(conf_monitor.equals("true"))	System.out.println(LogData+req_comment);
			if(LogFlag){
				if(conf_logfile.length()>0)	file.FileAdd(conf_logfile,LogData+req_comment+"\n");
			}
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	t@CXgHTML\bh
		//
		private String MakeFileList(String searchPath,String showPath){
			String msg=file.FileSort(file.FileSearch(searchPath));
			StringTokenizer st1,st2;
			String retmsg="",str1,name,size,date;
			String TitleColor="#cfcfcf";
			String ContColor1="#efefef";
			String ContColor2="#efefef";
			int i,j=0,k;
			
			retmsg ="<html>\n";
			retmsg+="<head>\n";
			retmsg+="<title>"+showPath+"</title>\n";
			retmsg+="</head>\n";
			retmsg+="<body bgcolor=\"white\">\n";
			retmsg+="<h3><b>"+showPath+"</b></h3>\n";
			retmsg+="<table border=\"0\">\n";
			retmsg+="<tr bgcolor=\""+TitleColor+"\"><th>File Name</th><th>Size(Bytes)</th><th>Last Modified</th></tr>\n";
			retmsg+="<tr bgcolor=\""+ContColor1+"\"><td><a href=\"../\">../</a></td><td>&lt;dir&gt;</td><td></td></tr>\n";
			st1=new StringTokenizer(msg,"\n");
			while(st1.hasMoreTokens()){
				str1=st1.nextToken();
				st2=new StringTokenizer(str1,",");
				name=st2.nextToken();
				size=st2.nextToken();
				date=st2.nextToken();
				if(j%2==0)	retmsg+="<tr bgcolor=\""+ContColor2+"\">";
				else		retmsg+="<tr bgcolor=\""+ContColor1+"\">";
				j++;
				retmsg+="<td><a href=\""+showPath+name+"\">"+name+"</a></td>";
				if     (name.endsWith("/"))	retmsg+="<td>&lt;dir&gt;</td>";
				else if(size.equals("-1"))	retmsg+="<td></td>";
				else						retmsg+="<td align=\"right\">"+size+"</td>";
				retmsg+="<td>"+date+"</td></tr>\n";
				st2=null;
			}
			st1=null;
			retmsg+="</table>\n";
			retmsg+="</body>\n";
			retmsg+="</html>\n";
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	G[bZ[W\bh
		//
		private String ErrorOut(int errno){
			String retmsg="";
			int i;
			if(0<err_max){
				for(i=0;i<err_max;i++){
					if(err_no[i]==errno){
						retmsg=file.FileRead(err_dir+err_msg[i]);
						break;
					}
				}
			}
			if(retmsg.equals(""))	retmsg="Error "+Integer.toString(errno)+"\r\n";
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	MIME-Type ̓\bhiȈՓIɊgqŔʂj
		//
		private String AnalyzeMimeType(String url){
			String retmsg="",str1,str2,str3;
			int i,j;
			j=-1;
			for(i=0;i<mime_max;i++){
				if(url.endsWith(mime_ext[i])){
					j=i;
					break;
				}
			}
			if(j==-1)	retmsg="application/octet-stream";
			else		retmsg=mime_type[i];
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	X|Xwb_\bh
		//	Qljhttp://www.asahi-net.or.jp/~ax2s-kmtn/ref/status.html
		//
		private String MakeHeadder(String HttpVersion,int status){
			String retmsg="";
			if     (status==200)	retmsg=HttpVersion+" 200 OK\r\n";
			else if(status==400)	retmsg=HttpVersion+" 400 Bad Request\r\n";
			else if(status==401)	retmsg=HttpVersion+" 401 Unauthorized\r\n";
			else if(status==403)	retmsg=HttpVersion+" 403 Forbidden\r\n";
			else if(status==404)	retmsg=HttpVersion+" 404 Not Found\r\n";
			else if(status==405)	retmsg=HttpVersion+" 405 Method Not Allowed\r\n";
			else					retmsg=HttpVersion+" 000 \r\n";
			retmsg+="Server: "+gServerName+"\r\n";
			retmsg+="Connection: close\r\n";
//			retmsg+="Content-Type: "+MimeType+"\r\n";
//			retmsg+="\r\n";
			return retmsg;
		}
		
		/////////////////////////////////////////////////////////////////////////
		//	CGIs
		//	QƁjhttp://www.vhp.jp/www/wwwcgi3.htm
		//
		private void ExecCGI(OutputStream out,String data,String param){
			String retmsg="";
			String path,cmd,ext,execcmd="",execpath="";;
			String str1="",str2,str3,str4,str5;
			int i,j,k;
			StringTokenizer st1;
			int BuffMax=1024;
			byte[] ReadData=new byte[BuffMax];
			String[] envt=null;
			
			i   =data.lastIndexOf(".");
			j   =data.lastIndexOf("/");
			path=data.substring(0  ,j);
			cmd =data.substring(j+1,i);
			ext =data.substring(i+1,data.length());
			
			//	for debug
			if(conf_debug.equals("true")){
				System.out.println("path =["+path +"]");	//	webroot/cgi-bin/counter
				System.out.println("cmd  =["+cmd  +"]");	//	counter
				System.out.println("ext  =["+ext  +"]");	//	class
				System.out.println("param=["+param+"]");	//	1
			}
			
			j=-1;
			for(i=0;i<cgi_type_max;i++){
				if(cgi_type[i].equals(ext)){
					j=i;
					break;
				}
			}
			if(j==-1){
				retmsg+="Content-Type: text/html\r\n";
				retmsg+="\r\n";
				retmsg+="<h3>Error 400 Bad Request</h3>\r\n";
				try{
					out.write(retmsg.getBytes());
				}
				catch(Exception e){}
			}
			else{
				for(i=0;i<path.length();i++){
					str1=path.substring(i,i+1);
					if(str1.equals("/"))	execpath+=File.separator;
					else					execpath+=str1;
				}
				if     (ext.equals("class"))	execcmd=cgi_cmd[j]+" "+cmd;
				else if(ext.equals("jar"))		execcmd=cgi_cmd[j]+" -jar "+cmd+"."+ext;
				else if(ext.equals("pl"))		execcmd=cgi_cmd[j]+" "+cmd+"."+ext;
				else if(ext.equals("cgi"))		execcmd=cgi_cmd[j]+" "+cmd+"."+ext;
				else{
					if(!cgi_cmd[j].equals(""))	execcmd=cgi_cmd[j]+" "+execpath+File.separator+cmd;
					else						execcmd=execpath+File.separator+cmd;
				}
				if(!param.equals("")){
					if(param.indexOf("=")!=-1){	//	ϐZbg
						st1=new StringTokenizer(param,"&");
						if(0<=req_contentlength){
							envt=new String[st1.countTokens()+1];
							envt[0]="CONTENT_LENGTH="+Integer.toString(req_contentlength);
							i=1;
							while(st1.hasMoreTokens()){
								envt[i++]=st1.nextToken();
							}
						}
						else{
							envt=new String[st1.countTokens()];
							i=0;
							while(st1.hasMoreTokens()){
								envt[i++]=st1.nextToken();
							}
						}
						st1=null;
					}
					else{
						envt=null;
						execcmd+=" "+param;
					}
				}
				try{
					File        pt=new File(path);
					Process     ps=Runtime.getRuntime().exec(execcmd,envt,pt);
					InputStream in=ps.getInputStream();
					while(true){
						i=in.read(ReadData);
						if(i==-1)	break;	//	EOF
						out.write(ReadData,0,i);
					}
					in.close();
					in=null;
				}
				catch(Exception e){}
			}
		}
	}
}
